﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OZX
{
    public class OzPDU_OZX_Login : OzPDU_OZX
    {

        //**********************************
        // Command ID
        //**********************************

        public override byte GetCommandID()
        {
            return Login; 
        }

        //**********************************
        // Data
        //**********************************

        public string Username;

        public string Password;

        public byte ProtocolVersion;

        //**********************************
        // Construct
        //**********************************
        public OzPDU_OZX_Login()
        {
            ProtocolVersion = 1;
        }

        //**********************************
        // Encode
        //**********************************
        protected override byte[] EncodeData()
        {
            var usernameBytes = OzCommonBytes.StringToBytes(Username);
            var passwordBytes = OzCommonBytes.StringToBytes(Password);
            var ret = new byte[1+usernameBytes.Length+passwordBytes.Length];
            ret[0] = ProtocolVersion;
            Buffer.BlockCopy(usernameBytes, 0, ret, 1, usernameBytes.Length);
            Buffer.BlockCopy(passwordBytes, 0, ret, usernameBytes.Length+1, passwordBytes.Length);
            return ret;
        }

        //**********************************
        // DecodeData
        //**********************************

        protected override void DecodeData(byte[] src, ref int offset)
        {
            ProtocolVersion = src[offset++];
            Username = OzCommonBytes.BytesToString(src, ref offset);
            Password = OzCommonBytes.BytesToString(src, ref offset);
        }
    }
}
