﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OZX
{
    public class OzPDU_OZX_Send_Resp : OzPDU_OZX
    {
        //**********************************
        // Command ID
        //**********************************

        public override byte GetCommandID()
        {
            return Send_Resp; 
        }

        //**********************************
        // Data
        //**********************************

        public bool Accepted;
        public string MessageID;
        public string RejectReason;

        //**********************************
        // Construct
        //**********************************
        public OzPDU_OZX_Send_Resp()
        {
            Accepted = true;
        }

        //**********************************
        // Encode
        //**********************************
        protected override byte[] EncodeData()
        {
            var messageIDBytes = OzCommonBytes.StringToBytes(MessageID);
            var rejectReasonBytes = OzCommonBytes.StringToBytes(RejectReason);

            var ret = new byte[ 1 + messageIDBytes.Length + rejectReasonBytes.Length];
            ret[0] = OzCommonBytes.BoolToByte(Accepted);
            Buffer.BlockCopy(messageIDBytes, 0, ret, 1, messageIDBytes.Length);
            Buffer.BlockCopy(rejectReasonBytes, 0, ret, 1+messageIDBytes.Length,rejectReasonBytes.Length);
            return ret;
        }

        //**********************************
        // DecodeData
        //**********************************

        protected override void DecodeData(byte[] src, ref int offset)
        {
            Accepted = OzCommonBytes.BytesToBool(src, ref offset);
            MessageID = OzCommonBytes.BytesToString(src, ref offset);
            RejectReason = OzCommonBytes.BytesToString(src, ref offset);
        }
    }
}
